diff --git a/sofort/ccenv/ccenv.sh b/sofort/ccenv/ccenv.sh
index 30e28fd..fdba47e 100644
--- a/sofort/ccenv/ccenv.sh
+++ b/sofort/ccenv/ccenv.sh
@@ -1126,6 +1126,9 @@ ccenv_set_os()
 			ccenv_tip=${ccenv_cchost%-*}
 			ccenv_os=${ccenv_tip#*-}
 			;;
+		*-*-solaris* )
+			ccenv_os='solaris'
+			;;
 		*-*-* )
 			ccenv_os=${ccenv_cchost#*-*-}
 			;;
@@ -1428,6 +1431,15 @@ ccenv_set_os_pe_switches()
 	fi
 }
 
+ccenv_set_os_gate_switches()
+{
+	if [ "$ccenv_os" = 'solaris' ]; then
+		if ! cfgtest_macro_definition 'AT_FDCWD'; then
+			ccenv_cflags_os="${ccenv_cflags_os} -D__EXTENSIONS__"
+		fi
+	fi
+}
+
 ccenv_output_defs()
 {
 	ccenv_in="$mb_project_dir/sofort/ccenv/ccenv.in"
@@ -1793,6 +1805,7 @@ ccenv_set_toolchain_variables()
 	ccenv_set_os_dso_linkage
 	ccenv_set_os_dso_patterns
 	ccenv_set_os_pe_switches
+	ccenv_set_os_gate_switches
 	ccenv_set_cc_attr_visibility_vars
 
 	ccenv_output_defs